'mcs43.prg: MCS on power of serial correlation tests in an ARX(1) model     
!n=30
!warmup=100
!warmupn=!warmup+!n    
workfile mcs43.wf1 u 1 !warmupn
!beta1=0 
!beta2=0.2
!beta3=1-!beta2 
!sigma=0.05
!rho=0.4
!gamma=0.8
rndseed 12345
smpl 1 1
genr y=0
genr x=nrnd 
genr u=!sigma*nrnd
smpl 2 !warmupn
genr x=!gamma*x(-1)+@sqrt(1-!gamma^2)*nrnd
genr u=!rho*u(-1)+!sigma*@sqrt(1-!rho^2)*nrnd                 
genr y=!beta1+!beta2*x+!beta3*y(-1)+u
smpl !warmup+1 !warmupn   
!R=10000                    
matrix (!R,8) simres
rndseed 9876544310     
for !rep=1 to !R                                   
   genr u=!rho*u(-1)+!sigma*@sqrt(1-!rho^2)*nrnd   
   genr y=!beta1+!beta2*x+!beta3*y(-1)+u
   equation eq1.ls y c x y(-1) 
   simres(!rep,1)=eq1.@dw
   genr resid1=resid
   genr resid1lag=resid1(-1)
   smpl !warmup+1 !warmup+1
   genr resid1lag=0
   smpl !warmup+1 !warmupn   
   equation eq2.ls resid1 resid1lag
   simres(!rep,2)=(eq2.@tstats(1))^2
   equation eq3.ls resid1 c x y(-1) resid1lag
   simres(!rep,3)=eq3.@tstats(4)
   genr resid1lag2=resid1lag(-1)
   smpl !warmup+1 !warmup+1
   genr resid1lag2=0
   smpl !warmup+1 !warmupn     
   equation eq4.ls resid1 c x y(-1) resid1lag resid1lag2
   simres(!rep,4)=!n*eq4.@r2
   simres(!rep,5)=((!n-5)/2)*(eq1.@ssr-eq4.@ssr)/eq4.@ssr
   genr resid1lag3=resid1lag2(-1)
   smpl !warmup+1 !warmup+1
   genr resid1lag3=0
   smpl !warmup+1 !warmupn     
   equation eq5.ls resid1 c x y(-1) resid1lag resid1lag2 resid1lag3
   simres(!rep,6)=!n*eq5.@r2
   simres(!rep,7)=((!n-6)/3)*(eq1.@ssr-eq5.@ssr)/eq5.@ssr
   simres(!rep,8)=eq1.@r2
next                                                  
simres.write mcs43sim.txt    
workfile mcs43sim.wf1 u 1 !R 
read mcs43sim.txt dw BP1 LMt1 LM2 LMF2 LM3 LMF3 R2 
genr rejBP1=BP1>@qchisq(0.95,1)   
genr rejLMt1L=LMt1<@qtdist(0.05,!n-4)
genr rejLMt1R=LMt1>@qtdist(0.95,!n-4)
genr rejLMt1=abs(LMt1)>@qnorm(0.975)
genr rejLM2=LM2>@qchisq(0.95,2)
genr rejLMF2=LMF2>@qfdist(0.95,2,!n-5)
genr rejLM3=LM3>@qchisq(0.95,3)
genr rejLMF3=LMF3>@qfdist(0.95,3,!n-6)


